



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>java.util.Collections.copy()：列表List浅拷贝</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">java.util.Collections.copy()：列表List浅拷贝</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-02 09:29:28 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>今天同事问我怎样将一个列表（list1）拷贝到另一个列表（list2），然后修改新的列表（list2）不会影响到旧的列表（list1），想了一想，这是深拷贝啊。</p>
<p>可是，除了循环new还有别的办法吗，想了又想，自己也是啥都不懂啊，赶紧百度学习一下，于是就找到了java.util.Collections.copy()，一开始还以为这个是个深拷贝呢，没想到还是个浅拷贝。虽然还没找到深拷贝的方法去解决同事的问题，但还是要学习一下这个浅拷贝，毕竟也是有用滴。</p>
<p>先写个单元测试试一下：</p>
<div>
<pre class="prettyprint linenums">@Test<br />
public void testCollectionsCopy() {<br />
    List&lt;String&gt; srcList = new ArrayList&lt;&gt;();<br />
    srcList.add("张三");<br />
    srcList.add("李四");<br />
    srcList.add("王五");

    List&lt;String&gt; descList = new ArrayList&lt;&gt;(3);

    Collections.copy(descList, srcList);

    for (String desc : descList) {<br />
        System.out.println(desc);<br />
    }<br />
}&nbsp;</pre>
</div>
<p>结果报错，悲剧了：java.lang.IndexOutOfBoundsException: Source does not fit in dest。下标越界啊。</p>
<p>赶紧看看java.util.Collections.copy()的源码压压惊。</p>
<div>
<pre class="prettyprint linenums">public static &lt;T&gt; void copy(List&lt;? super T&gt; dest, List&lt;? extends T&gt; src) {<br />
        int srcSize = src.size();<br />
        if (srcSize &gt; dest.size())<br />
            throw new IndexOutOfBoundsException("Source does not fit in dest");

        if (srcSize &lt; COPY_THRESHOLD ||<br />
            (src instanceof RandomAccess &amp;&amp; dest instanceof RandomAccess)) {<br />
            for (int i=0; i&lt;srcSize; i++)<br />
                dest.set(i, src.get(i));<br />
        } else {<br />
            ListIterator&lt;? super T&gt; di=dest.listIterator();<br />
            ListIterator&lt;? extends T&gt; si=src.listIterator();<br />
            for (int i=0; i&lt;srcSize; i++) {<br />
                di.next();<br />
                di.set(si.next());<br />
            }<br />
        }<br />
    }&nbsp;</pre>
</div>
<p>通过看源码，发现这个方法是有目标数组和源数组的元素个数进行比较的操作，如果目标数组的元素个数小于源数组的元素个数，则抛出下标越界的异常。</p>
<p>可是我已经指定了descList的容量为3了呀！难道这个容量不等于实际元素个数吗？通过打印descList.size()才发现，descList的实际元素个数为0。这样我就知道，指定的descList容量为3，只是指定了descList当前容纳的元素个数为3，即descList的容纳能力（Capacity）为3，并不代表descList中有了三个实际的元素。初始化时实际元素个数（Size）永远为0，只有在进行add()和remove()等相关操作时，实际元素个数才会发生改变。</p>
<p>好吧，元凶找到了。只要给descList塞一些空对象就完事了。</p>
<div>
<pre class="prettyprint linenums">@Test<br />
public void testCollectionsCopy() {<br />
    List&lt;String&gt; srcList = new ArrayList&lt;&gt;();<br />
    srcList.add("张三");<br />
    srcList.add("李四");<br />
    srcList.add("王五");

    List&lt;String&gt; descList = new ArrayList&lt;&gt;(3);<br />
    descList.add(null);<br />
    descList.add(null);<br />
    descList.add(null);<br />
    descList.add("赵六");<br />
    System.out.println(descList.size());

    Collections.copy(descList, srcList);

    for (String desc : descList) {<br />
        desc = desc + "是笨蛋";<br />
        System.out.println(desc);<br />
    }<br />
}</pre>
</div>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/842514/201902/842514-20190226111442968-1476051006.png" /></p>
<p>这里可以发现，给descList指定容量好像并没有什么用，因为ArrayList是可变动态数组队列（底层实现是Array数组），长度会随着实际元素个数自动增大，那么到底是有什么用呢？（保留疑问，这个要看看Java的集合恶补一下知识啦，或者有没有大佬告诉我一下啊）</p>
<p>也可以中JDK7中新增加的方法Array.asList()来实现，即数组转List。</p>
<div>
<pre class="prettyprint linenums">@Test<br />
public void testCollectionsCopy() {<br />
    List&lt;String&gt; srcList = new ArrayList&lt;&gt;();<br />
    srcList.add("张三");<br />
    srcList.add("李四");<br />
    srcList.add("王五");

    List&lt;String&gt; descList = Arrays.asList(new String[srcList.size()]);<br />
    System.out.println(descList.size());

    Collections.copy(descList, srcList);

    for (String desc : descList) {<br />
        desc = desc + "是笨蛋";<br />
        System.out.println(desc);<br />
    }<br />
}</pre>
</div>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/842514/201902/842514-20190226112013672-684889278.png" /></p>
<p>其实也可以用addAll()。</p>
<div>
<pre class="prettyprint linenums">@Test<br />
public void testCollectionsCopy() {<br />
    List&lt;String&gt; srcList = new ArrayList&lt;&gt;();<br />
    srcList.add("张三");<br />
    srcList.add("李四");<br />
    srcList.add("王五");

    List&lt;String&gt; descList = new ArrayList&lt;&gt;();<br />
    descList.addAll(srcList);<br />
    System.out.println(descList.size());

    for (String desc : descList) {<br />
        desc = desc + "是笨蛋";<br />
        System.out.println(desc);<br />
    }<br />
}</pre>
</div>
<p>嘻嘻，就这些了，接着找找深拷贝的知识吧，顺便还要总结下浅拷贝和深拷贝的知识呢。</p>
<p>"愿你既可以安于朝九晚五，波澜不惊；又能随时出发，踏浪远航。"</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/49g3r60q.html">iOS应用文件夹</a>
		</li>
						<li><a href="https://www.batexi.com/a/m9657zjq.html">centos5&period;11 repo 安装mysql5&period;7</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9pgp679.html">（Hibernate进阶）Hibernate映射&mdash;&mdash;多对多关联映射（八）</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2gdgl8.html">flask-admin众博客概述</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8m1ym28.html">CSS选择器性能分析</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qnrpek9.html">单源最短路径&mdash;&mdash;Dijkstra算法学习</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gm1o1z9.html">shell中cut用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okjxkp9.html">用CorelDRAW勾画对象轮廓图的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxnrn108.html">Eclipes中使用BASE64Encoder及BASE64Decoder报错</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1nkmn9.html">详解SSH注解配置，bean注解、事物注解等</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vw6dn8.html">PHP获取网址的PR值</a>
		</li>
						<li><a href="https://www.batexi.com/a/950zlk68.html">linux&lpar;5&rpar;--补充（管道&vert;  &sol;  重定向&amp;gt&semi; &sol;  xargs）&sol;find 与xargs结合使用&sol;vi&comma;grep&comma;sed，awk&lpar;支持正则表达式的工具程序&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jz6e4w8.html">&period;Net的垃圾回收机制（GC）之拙见&mdash;&mdash;托管类型的垃圾回收</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4z5k109.html">Alpha冲刺Day7</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpz6z69.html">ROS&lowbar;Kinetic&lowbar;27 在ROS中使用Cartographer进行SLAM</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r55er7q.html">从零开始学安全&lpar;七&rpar;●Linux基础命令学习笔记</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7owdmg8.html">Spring XML配置里的Bean自动装配</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdw33yz9.html">emmc基础技术8：操作模式2-device identification mode</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7o61pg8.html">【centos】centos命令总结&lpar;持续更新&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o4kklpq.html">Racket Cheat Sheet</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q1rv2p48.html">如何指定一个计划和目标&mdash;&mdash;6W</a>
			</li>
						<li><a href="https://www.batexi.com/a/8o14oepq.html">Eclipse debug 断点不能调试 ，Eclipse Unable to install breakpoint in 解决办法</a>
			</li>
						<li><a href="https://www.batexi.com/a/9r5n367q.html">Ecelipse上添加Server</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4jp230q.html">Java面试知识点之设计模式（一）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q25kejvq.html">因PHP漏洞，超过4&period;5万个中国网站被攻击</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1rvxx68.html">&lbrack;国家集训队&rsqb;happiness</a>
			</li>
						<li><a href="https://www.batexi.com/a/q25k1pxq.html">ORACLE SPA</a>
			</li>
						<li><a href="https://www.batexi.com/a/qll13p6q.html">selenium之选项卡管理</a>
			</li>
						<li><a href="https://www.batexi.com/a/q25klpwq.html">&lbrack;LeetCode&rsqb;最大系列&lpar;最大正方形221&comma;最大加号标志764&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/9r5nxzrq.html">String，StringBuffer，StringBuilder的区别与共同点</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
